Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3297)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 3298)
@@ -1068,40 +784,46 @@
 !------------------------------------------------------------------------------!
 
-   SUBROUTINE chem_check_data_output( var, unit, i, ilen, k )
-
-      IMPLICIT NONE
-
-      CHARACTER (LEN=*) ::  unit     !<
-      CHARACTER (LEN=*) ::  var      !<
-
-      INTEGER(iwp) ::  i, ilen, k, lsp
-
-      CHARACTER(len=16)    ::  spec_name
-
-      unit = 'illegal'
-
-      spec_name = TRIM(var(4:))             !< var 1:3 is 'kc_'.
-
-       DO lsp=1,nspec
-         IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
-            unit = 'ppm'
-         ENDIF
-         ! It is possible  to plant PM10 and PM25 into the gasphase chemistry code 
-!        ! as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
-!        ! set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
-         IF (spec_name(1:2) == 'PM')   THEN  
-            unit = 'ug m-3'
-         ENDIF
-       ENDDO
-
-       DO lsp=1,nphot                                                     
-         IF (TRIM(spec_name) == TRIM(phot_frequen(lsp)%name))   THEN
-            unit = 'sec-1'
-         ENDIF
-       ENDDO
+    SUBROUTINE chem_check_data_output( var, unit, i, ilen, k )
+
+
+       USE control_parameters,                                                 &
+          ONLY: data_output, message_string
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN=*) ::  unit     !<
+       CHARACTER (LEN=*) ::  var      !<
+
+       INTEGER(iwp) :: i, lsp
+       INTEGER(iwp) :: ilen
+       INTEGER(iwp) :: k
+
+       CHARACTER(len=16)    ::  spec_name
+
+       unit = 'illegal'
+
+       spec_name = TRIM(var(4:))             !< var 1:3 is 'kc_'.
+
+          DO lsp=1,nspec
+             IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name))   THEN
+                unit = 'ppm'
+             ENDIF
+!            It is possible  to plant PM10 and PM25 into the gasphase chemistry code 
+!            as passive species (e.g. 'passive' in GASPHASE_PREPROC/mechanisms):
+!            set unit to micrograms per m**3 for PM10 and PM25 (PM2.5)
+             IF (spec_name(1:2) == 'PM')   THEN  
+            unit = 'kg m-3'
+             ENDIF
+          ENDDO
+
+          DO lsp=1,nphot                                                     
+             IF (TRIM(spec_name) == TRIM(phot_frequen(lsp)%name))   THEN
+                unit = 'sec-1'
+             ENDIF
+          ENDDO
 
 
        RETURN
-   END SUBROUTINE chem_check_data_output
+    END SUBROUTINE chem_check_data_output
 !
 !------------------------------------------------------------------------------!
@@ -1112,49 +834,222 @@
 !------------------------------------------------------------------------------!
 
-   SUBROUTINE chem_check_data_output_pr( variable, var_count, unit, dopr_unit )
-
-
-    USE arrays_3d,                                                             &
-        ONLY: zu
-
-    USE control_parameters,                                                    &
-        ONLY: data_output_pr, message_string, air_chemistry
-
-    USE indices
-
-    USE profil_parameter
-
-    USE statistics
-
-
-    IMPLICIT NONE
-
-    CHARACTER (LEN=*) ::  unit     !< 
-    CHARACTER (LEN=*) ::  variable !< 
-    CHARACTER (LEN=*) ::  dopr_unit
-    CHARACTER(len=16) ::  spec_name
- 
-    INTEGER(iwp) ::  var_count, lsp  !<
+    SUBROUTINE chem_check_data_output_pr( variable, var_count, unit, dopr_unit )
+
+       USE arrays_3d
+       USE control_parameters,                                                    &
+           ONLY: data_output_pr, message_string, air_chemistry
+       USE indices
+       USE profil_parameter
+       USE statistics
+
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN=*) ::  unit     !< 
+       CHARACTER (LEN=*) ::  variable !< 
+       CHARACTER (LEN=*) ::  dopr_unit
+       CHARACTER(len=16) ::  spec_name
     
-
-    spec_name = TRIM(variable(4:))    
-!             write(9,*) 'fm #32 .. air_chemistry ', air_chemistry
+       INTEGER(iwp) ::  var_count, lsp  !<
+       
+
+       spec_name = TRIM(variable(4:))    
 
           IF (  .NOT.  air_chemistry )  THEN
-                 message_string = 'data_output_pr = ' //                        &
-                 TRIM( data_output_pr(var_count) ) // ' is not imp' // &
-                          'lemented for air_chemistry = .FALSE.'
-!                CALL message( 'check_parameters', 'PA0XXX', 1, 2, 0, 6, 0 )
+             message_string = 'data_output_pr = ' //                        &
+             TRIM( data_output_pr(var_count) ) // ' is not imp' // &
+                         'lemented for air_chemistry = .FALSE.'
+             CALL message( 'chem_check_parameters', 'CM0433', 1, 2, 0, 6, 0 )              
+
           ELSE
              DO lsp = 1, nspec
                 IF (TRIM( spec_name ) == TRIM( chem_species(lsp)%name ) ) THEN 
-                    dopr_index(var_count) = 900 
-                    dopr_unit  = 'ppm'
-                    hom(:,2,900,:) = SPREAD( zu, 2, statistic_regions+1 )
+                   cs_pr_count = cs_pr_count+1
+                   cs_pr_index(cs_pr_count) = lsp
+                   dopr_index(var_count) = pr_palm+cs_pr_count  
+                   dopr_unit  = 'ppm'
+                   IF (spec_name(1:2) == 'PM')   THEN
+                        dopr_unit = 'kg m-3'
+                   ENDIF
+                      hom(:,2, dopr_index(var_count),:) = SPREAD( zu, 2, statistic_regions+1 )
+                      unit = dopr_unit  
                 ENDIF
              ENDDO
           ENDIF
 
-   END SUBROUTINE chem_check_data_output_pr
+    END SUBROUTINE chem_check_data_output_pr
+
+!
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Check parameters routine for chemistry_model_mod
+!------------------------------------------------------------------------------!
+    SUBROUTINE chem_check_parameters
+
+       IMPLICIT NONE
+
+       LOGICAL                        ::  found
+       INTEGER (iwp)                  ::  lsp_usr      !< running index for user defined chem spcs 
+       INTEGER (iwp)                  ::  lsp          !< running index for chem spcs.
+
+
+!!--   check for chemical reactions status
+       IF ( chem_gasphase_on )  THEN
+          message_string = 'Chemical reactions: ON'
+          CALL message( 'chem_check_parameters', 'CM0421', 0, 0, 0, 6, 0 )
+       ELSEIF ( .not. (chem_gasphase_on) ) THEN
+          message_string = 'Chemical reactions: OFF'
+          CALL message( 'chem_check_parameters', 'CM0422', 0, 0, 0, 6, 0 )
+       ENDIF
+
+!--    check for chemistry time-step
+       IF ( call_chem_at_all_substeps )  THEN
+          message_string = 'Chemistry is calculated at all meteorology time-step'
+          CALL message( 'chem_check_parameters', 'CM0423', 0, 0, 0, 6, 0 )
+       ELSEIF ( .not. (call_chem_at_all_substeps) ) THEN
+          message_string = 'Sub-time-steps are skipped for chemistry time-steps'
+          CALL message( 'chem_check_parameters', 'CM0424', 0, 0, 0, 6, 0 )
+       ENDIF
+
+!--    check for photolysis scheme 
+       IF ( (photolysis_scheme /= 'simple') .AND. (photolysis_scheme /= 'constant')  )  THEN
+          message_string = 'Incorrect photolysis scheme selected, please check spelling'
+          CALL message( 'chem_check_parameters', 'CM0425', 1, 2, 0, 6, 0 )
+       ENDIF
+
+!--    check for  decycling of chem species
+       IF ( (.not. any(decycle_method == 'neumann') ) .AND. (.not. any(decycle_method == 'dirichlet') ) )   THEN
+          message_string = 'Incorrect boundary conditions. Only neumann or dirichlet     &
+          available for decycling chemical species ' 
+          CALL message( 'chem_check_parameters', 'CM0426', 1, 2, 0, 6, 0 )
+       ENDIF
+
+!--    check for initial chem species input
+       lsp_usr = 1
+       lsp     = 1
+       DO WHILE ( cs_name (lsp_usr) /= 'novalue')
+          found = .FALSE.
+          DO lsp = 1, nvar
+             IF ( TRIM(cs_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
+                found = .TRUE.
+                EXIT
+             ENDIF 
+          ENDDO
+          IF ( .not. found ) THEN
+             message_string = 'Incorrect input for initial surface vaue: ' // TRIM(cs_name(lsp_usr))
+             CALL message( 'chem_check_parameters', 'CM0427', 0, 1, 0, 6, 0 )
+          ENDIF
+          lsp_usr = lsp_usr + 1
+       ENDDO
+
+!--    check for surface  emission flux chem species
+
+       lsp_usr = 1
+       lsp     = 1
+       DO WHILE ( surface_csflux_name (lsp_usr) /= 'novalue')
+          found = .FALSE.
+          DO lsp = 1, nvar
+             IF ( TRIM(surface_csflux_name (lsp_usr)) == TRIM(chem_species(lsp)%name) ) THEN
+                found = .TRUE.
+                EXIT
+             ENDIF 
+          ENDDO
+          IF ( .not. found ) THEN
+             message_string = 'Incorrect input of chemical species for surface emission fluxes: '  &
+                               // TRIM(surface_csflux_name(lsp_usr))
+             CALL message( 'chem_check_parameters', 'CM0428', 0, 1, 0, 6, 0 )
+          ENDIF
+          lsp_usr = lsp_usr + 1
+       ENDDO
+
+    END SUBROUTINE chem_check_parameters
+
+!
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Subroutine defining 2D output variables for chemical species
+!> @todo: Remove "mode" from argument list, not used.
+!------------------------------------------------------------------------------!
+    
+    SUBROUTINE chem_data_output_2d( av, variable, found, grid, mode, local_pf,   &
+                                     two_d, nzb_do, nzt_do, fill_value )
+    
+       USE indices
+
+       USE kinds
+
+       USE pegrid,             ONLY: myid, threads_per_task
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN=*) ::  grid       !<
+       CHARACTER (LEN=*) ::  mode       !< 
+       CHARACTER (LEN=*) ::  variable   !< 
+       INTEGER(iwp) ::  av              !< flag to control data output of instantaneous or time-averaged data
+       INTEGER(iwp) ::  nzb_do          !< lower limit of the domain (usually nzb)
+       INTEGER(iwp) ::  nzt_do          !< upper limit of the domain (usually nzt+1)
+       LOGICAL      ::  found           !< 
+       LOGICAL      ::  two_d           !< flag parameter that indicates 2D variables (horizontal cross sections)
+       REAL(wp)     ::  fill_value 
+       REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< 
+
+       !-- local variables.
+       CHARACTER(len=16)    ::  spec_name
+       INTEGER(iwp) ::  lsp
+       INTEGER(iwp) ::  i               !< grid index along x-direction
+       INTEGER(iwp) ::  j               !< grid index along y-direction
+       INTEGER(iwp) ::  k               !< grid index along z-direction
+       INTEGER(iwp) ::  m               !< running index surface elements
+       INTEGER(iwp) ::  char_len        !< length of a character string
+       found = .TRUE.
+       char_len  = LEN_TRIM(variable)
+
+       spec_name = TRIM( variable(4:char_len-3) )
+
+          DO lsp=1,nspec
+             IF (TRIM(spec_name) == TRIM(chem_species(lsp)%name)    .AND.                             &
+                   ( (variable(char_len-2:) == '_xy')               .OR.                              &
+                     (variable(char_len-2:) == '_xz')               .OR.                              &
+                     (variable(char_len-2:) == '_yz') ) )               THEN             
+
+                   IF(myid == 0)  WRITE(6,*) 'Output of species ' // TRIM(variable)  //               &
+                                                            TRIM(chem_species(lsp)%name)       
+                IF (av == 0) THEN
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb_do, nzt_do
+                              local_pf(i,j,k) = MERGE(                                                &
+                                                 chem_species(lsp)%conc(k,j,i),                       &
+                                                 REAL( fill_value, KIND = wp ),                       &
+                                                 BTEST( wall_flags_0(k,j,i), 0 ) )
+
+
+                         ENDDO
+                      ENDDO
+                   ENDDO
+              
+                ELSE
+                   DO  i = nxl, nxr
+                      DO  j = nys, nyn
+                         DO  k = nzb_do, nzt_do
+                              local_pf(i,j,k) = MERGE(                                                &
+                                                 chem_species(lsp)%conc(k,j,i),                       &
+                                                 REAL( fill_value, KIND = wp ),                       &
+                                                 BTEST( wall_flags_0(k,j,i), 0 ) )
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                ENDIF
+                 grid = 'zu'           
+             ENDIF
+          ENDDO
+
+          RETURN
+     
+    END SUBROUTINE chem_data_output_2d      
+
 !
 !------------------------------------------------------------------------------!
@@ -1165,37 +1060,34 @@
 !------------------------------------------------------------------------------!
 
-
-   SUBROUTINE chem_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
-
-
-      USE indices
-
-      USE kinds
-
-
-      IMPLICIT NONE
-
-      CHARACTER (LEN=*) ::  variable !<
-
-      INTEGER(iwp) ::  av    !<
-      INTEGER(iwp) ::  nzb_do !< lower limit of the data output (usually 0)
-      INTEGER(iwp) ::  nzt_do !< vertical upper limit of the data output (usually nz_do3d)
-
-      LOGICAL      ::  found !<
-
-      REAL(wp) ::  fill_value !<
-      REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf 
-
-
-      !-- local variables
-
-      INTEGER              ::  i, j, k, lsp
-      CHARACTER(len=16)    ::  spec_name
-
-
-      found = .FALSE.
-
-      spec_name = TRIM(variable(4:))
-!av == 0
+    SUBROUTINE chem_data_output_3d( av, variable, found, local_pf, fill_value, nzb_do, nzt_do )
+
+
+       USE indices
+
+       USE kinds
+
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN=*)    ::  variable     !<
+       INTEGER(iwp)         ::  av           !<
+       INTEGER(iwp) ::  nzb_do               !< lower limit of the data output (usually 0)
+       INTEGER(iwp) ::  nzt_do               !< vertical upper limit of the data output (usually nz_do3d)
+
+       LOGICAL      ::  found                !<
+
+       REAL(wp)             ::  fill_value !<
+       REAL(sp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf 
+
+
+       !-- local variables
+
+       INTEGER              ::  i, j, k, lsp
+       CHARACTER(len=16)    ::  spec_name
+
+
+       found = .FALSE.
+
+       spec_name = TRIM(variable(4:))
 
        DO lsp=1,nspec
@@ -1229,10 +1121,10 @@
              ENDIF
 
-            found = .TRUE.
+             found = .TRUE.
           ENDIF
        ENDDO
 
        RETURN
-   END SUBROUTINE chem_data_output_3d
+    END SUBROUTINE chem_data_output_3d
 !
 !------------------------------------------------------------------------------!
